import 'package:url_launcher/url_launcher.dart';
import 'dart:io';

void showInBrowser(String url) async {
  if (await canLaunchUrl(Uri.parse(url))) {
    launchUrl(Uri.parse(url));
  } else {}
}

Future<void> makePhoneCall(String phoneNumber) async {
  final Uri launchUri = Uri(
    scheme: 'tel',
    path: phoneNumber,
  );
  await launchUrl(launchUri);
}

void launchCommunication(
    String method, String contactInfo, String message) async {
  String url;

  if (Platform.isIOS) {
    switch (method) {
      case 'phone':
        url = 'tel:$contactInfo';
        break;
      case 'sms':
        url = 'sms:$contactInfo?body=${Uri.encodeComponent(message)}';
        break;
      case 'whatsapp':
        url =
            'https://api.whatsapp.com/send?phone=$contactInfo&text=${Uri.encodeComponent(message)}';
        break;
      case 'email':
        url =
            'mailto:$contactInfo?subject=Subject&body=${Uri.encodeComponent(message)}';
        break;
      default:
        return;
    }
  } else if (Platform.isAndroid) {
    switch (method) {
      case 'phone':
        url = 'tel:$contactInfo';
        break;
      case 'sms':
        url = 'sms:$contactInfo?body=${Uri.encodeComponent(message)}';
        break;
      case 'whatsapp':
        // Check if WhatsApp is installed
        final bool whatsappInstalled =
            await canLaunchUrl(Uri.parse('whatsapp://'));
        if (whatsappInstalled) {
          url =
              'whatsapp://send?phone=$contactInfo&text=${Uri.encodeComponent(message)}';
        } else {
          // Provide an alternative action, such as opening the WhatsApp Web API
          url =
              'https://api.whatsapp.com/send?phone=$contactInfo&text=${Uri.encodeComponent(message)}';
        }
        break;
      case 'email':
        url =
            'mailto:$contactInfo?subject=Subject&body=${Uri.encodeComponent(message)}';
        break;
      default:
        return;
    }
  } else {
    return;
  }

  if (await canLaunchUrl(Uri.parse(url))) {
    await launchUrl(Uri.parse(url));
  } else {}
}
